## golang-github-mendersoftware-mender-artifact 3.0.0+really2.4.0

=== Makefile ===
GO ?= go
GOFMT ?= gofmt
V ?=
PKGS = $(shell go list ./... | grep -v vendor)
BUILDFILES = $(shell find cli/mender-artifact \( -path ./vendor -o -path ./Godeps \) -prune \
	                     -o -type f -name '*.go' -print |  tr ' ' '\n' | grep -v _test.go)
PKGNAME = mender-artifact
PKGFILES = $(shell find . \( -path ./vendor -o -path ./Godeps \) -prune \
		-o -type f -name '*.go' -print)
PKGFILES_notest = $(shell echo $(PKGFILES) | tr ' ' '\n' | grep -v _test.go)
GOCYCLO ?= 15

CGO_ENABLED=1
export CGO_ENABLED

INSTALL_DIR=cli/mender-artifact

TOOLS = \
	github.com/fzipp/gocyclo \
	github.com/opennota/check/cmd/varcheck \
	github.com/mendersoftware/deadcode

VERSION = $(shell git describe --tags --dirty --exact-match 2>/dev/null || git rev-parse --short HEAD)

GO_LDFLAGS = \
	-ldflags "-X main.Version=$(VERSION)"

ifeq ($(V),1)
BUILDV = -v
endif

TAGS =
ifeq ($(LOCAL),1)
TAGS += local
endif

ifneq ($(TAGS),)
BUILDTAGS = -tags '$(TAGS)'
endif

build:
	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME) $(BUILDFILES)

install:
	cd $(INSTALL_DIR) && $(GO) install $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)

clean:
	$(GO) clean
	rm -f coverage.txt coverage-tmp.txt

get-tools:
	set -e ; for t in $(TOOLS); do \
		echo "-- go getting $$t"; \
		go get -u $$t; \
	done

check: test extracheck

tooldep:
	echo "check if mtools is installed on the system"
	mtools --version

test: tooldep
	$(GO) test -v $(PKGS)

extracheck:
	echo "-- checking if code is gofmt'ed"
	if [ -n "$$($(GOFMT) -d $(PKGFILES))" ]; then \
		echo "-- gofmt check failed"; \
		echo $GOFMT -d $PKGFILES \
		/bin/false; \
	fi
	echo "-- checking with govet"
	$(GO) tool vet -unsafeptr=false $(PKGFILES_notest)
	echo "-- checking for dead code"
	deadcode
	echo "-- checking with varcheck"
	varcheck .
	echo "-- checking cyclometric complexity > $(GOCYCLO)"
	gocyclo -over $(GOCYCLO) $(PKGFILES_notest)

cover: coverage
	$(GO) tool cover -func=coverage.txt

htmlcover: coverage
	$(GO) tool cover -html=coverage.txt

coverage:
	rm -f coverage.txt
	echo 'mode: set' > coverage.txt
	set -e ; for p in $(PKGS); do \
		rm -f coverage-tmp.txt;  \
		$(GO) test -coverprofile=coverage-tmp.txt $$p ; \
		if [ -f coverage-tmp.txt ]; then \
			cat coverage-tmp.txt |grep -v 'mode:' | cat >> coverage.txt; \
		fi; \
	done
	rm -f coverage-tmp.txt

.PHONY: build clean get-tools test check \
	cover htmlcover coverage tooldep

## golang-github-mendersoftware-mender-artifact 2.4.0

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (2.4.0-3) unstable; urgency=medium

  * Add dependency on e2fsprogs for debugfs

 -- Andreas Henriksson <andreas@fatal.se>  Thu, 24 Jan 2019 10:27:23 +0100

golang-github-mendersoftware-mender-artifact (2.4.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 22 Jan 2019 13:41:20 +0100

golang-github-mendersoftware-mender-artifact (2.4.0-1) experimental; urgency=medium

  * debian/watch: update regexp to know b means beta
  * New upstream version 2.4.0

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 15 Dec 2018 15:43:57 +0100

golang-github-mendersoftware-mender-artifact (2.3.0b1+git20181022.1bedfca-1) experimental; urgency=medium

  * Initial release (Closes: #914118)

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 19 Nov 2018 18:03:36 +0100

=== debian/control ===
Source: golang-github-mendersoftware-mender-artifact
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Andreas Henriksson <andreas@fatal.se>
Build-Depends: debhelper (>= 11),
               dh-golang,
               golang-any,
               golang-github-pkg-errors-dev,
               golang-github-stretchr-testify-dev,
               golang-github-urfave-cli-dev,
               golang-logrus-dev,
               golang-github-mendersoftware-mendertesting-dev,
               e2fsprogs <!nocheck>,
               parted <!nocheck>,
               mtools <!nocheck>
Standards-Version: 4.2.1
Homepage: https://github.com/mendersoftware/mender-artifact
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-mendersoftware-mender-artifact
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-mendersoftware-mender-artifact.git
XS-Go-Import-Path: github.com/mendersoftware/mender-artifact
Testsuite: autopkgtest-pkg-go

Package: golang-github-mendersoftware-mender-artifact-dev
Architecture: all
Depends: ${misc:Depends},
         golang-github-pkg-errors-dev,
         golang-github-stretchr-testify-dev,
         golang-github-urfave-cli-dev,
         golang-logrus-dev,
         golang-github-mendersoftware-mendertesting-dev
Description: Library for managing Mender artifact files
 Mender Artifacts Library Mender is an open source over-the-air (OTA)
 software updater for embedded Linux devices. Mender comprises a client
 running at the embedded device, as well as a server that manages
 deployments across many devices.
 .
 This repository contains the artifacts library, which is used by the
 Mender client, command line interface, server and for build integration
 with the Yocto Project.
 .
 The artifacts library makes it easy to programmatically work with a
 Mender artifact, which is a file that can be recognized by its .mender
 suffix. Mender artifacts can contain binaries, metadata, checksums,
 signatures and scripts that are used during a deployment. The artifact
 format acts as a wrapper, and uses the tar format to bundle several
 files into one.
 .
 In its simplest form, an artifact contains just a rootfs image, along
 with its checksum, id and device type compatibility.
 .
 The artifacts library might also be useful for other updaters or
 purposes. We are always happy to see other uses of it!
 .
 Mender logo Getting started To start using Mender, we recommend that
 you begin with the Getting started section in the Mender documentation
 (https://docs.mender.io/).  Using the library You can use the parser
 and reader in go in the standard way:
 .
 import (
         "github.com/mendersoftware/mender-artifact/parser"
         "github.com/mendersoftware/mender-artifact/reader"
        )
 .
 For sample usage, please see the Mender client source code
 (https://github.com/mendersoftware/mender).

Package: mender-artifact
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, e2fsprogs, parted, mtools
Description: utility to generate .mender artifacts
 Mender Artifacts Library Mender is an open source over-the-air (OTA)
 software updater for embedded Linux devices. Mender comprises a client
 running at the embedded device, as well as a server that manages
 deployments across many devices.
 .
 This package contains the mender-artifact program which is used to generate
 the artifacts needed for mender OTA updates. The artifacts are generated
 from your existing ext4 rootfs image that you built for direct device
 deployments.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE := 1
export DH_GOLANG_INSTALL_EXTRA := cli/mender-artifact/mender_test.img \
	cli/mender-artifact/mender_test.sdimg \
	cli/mender-artifact/mender_test.img.broken \
	cli/mender-artifact/mender_test_fat.sdimg
export DH_GOLANG_EXCLUDES := github.com/mendersoftware/mender-artifact$
export DH_GOLANG_EXCLUDES_ALL := 0

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install
	# hmm... seems to be created by cli/mender-artifact/copy_test.go
	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/-
	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/foo
	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/foo.txt
	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/output.txt

## golang-github-mendersoftware-mender-artifact 3.0.0

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.0.0-2) unstable; urgency=medium

  * Remove new dummy files created by unit tests
  * Add Lluis in debian/control Uploaders list

 -- Lluis Campos <lluis.campos@northern.tech>  Wed, 22 May 2019 13:24:11 +0200

golang-github-mendersoftware-mender-artifact (3.0.0-1) experimental; urgency=medium

  * New upstream version 3.0.0
  * Drop debian/patches/*, now fixed upstream
  * Add patch to switch to remyoudompheng go-liblzma
  * Add new golang-github-remyoudompheng-go-liblzma-dev build-dep
  * Bump years in debian/copyright

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 17 May 2019 13:00:32 +0200

golang-github-mendersoftware-mender-artifact (2.4.0-6) unstable; urgency=medium

  * Extend full-path patch to also cover /sbin/blkid

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 02 Feb 2019 09:25:16 +0100

golang-github-mendersoftware-mender-artifact (2.4.0-5) unstable; urgency=medium

  * Extend full-path patch to also cover /sbin/parted

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 01 Feb 2019 15:04:09 +0100

golang-github-mendersoftware-mender-artifact (2.4.0-4) unstable; urgency=medium

  * Fix 'mender-artifact -version' output
  * Add missing Built-Using field to binary package
  * Add 0001-Use-full-path-for-tools-found-in-sbin.patch

 -- Andreas Henriksson <andreas@fatal.se>  Wed, 30 Jan 2019 22:25:45 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/pkg-info.mk
 
 #export DH_VERBOSE := 1
 export DH_GOLANG_INSTALL_EXTRA := cli/mender-artifact/mender_test.img \
@@ -10,11 +12,21 @@
 
 %:
 	dh $@ --buildsystem=golang --with=golang
+	
+override_dh_auto_build:
+	dh_auto_build -O--buildsystem=golang -- \
+		-ldflags "-X main.Version=$(DEB_VERSION)"
 
 override_dh_auto_install:
 	dh_auto_install
-	# hmm... seems to be created by cli/mender-artifact/copy_test.go
+	# Test files created by cli/mender-artifact/copy_test.go
 	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/-
 	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/foo
 	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/foo.txt
 	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/output.txt
+	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/test.txt
+	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/dummy-file
+	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/mender_test_fat.sdimg
+	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/mender_test.img
+	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/mender_test.sdimg
+	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/mender_test.img.broken

## golang-github-mendersoftware-mender-artifact 3.0.0+really2.4.0

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.0.0+really2.4.0-1) unstable; urgency=medium

  * Team upload.
  * Revert all changes between 2.4.0-6 and 3.0.0-2.
    See https://bugs.debian.org/928227 for a rationale.

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 08 Jun 2019 23:08:00 +0200

=== debian/control ===
--- 
+++ 
@@ -67,6 +67,7 @@
 
 Package: mender-artifact
 Architecture: any
+Built-Using: ${misc:Built-Using}
 Depends: ${misc:Depends}, ${shlibs:Depends}, e2fsprogs, parted, mtools
 Description: utility to generate .mender artifacts
  Mender Artifacts Library Mender is an open source over-the-air (OTA)

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

#export DH_VERBOSE := 1
export DH_GOLANG_INSTALL_EXTRA := cli/mender-artifact/mender_test.img \
	cli/mender-artifact/mender_test.sdimg \
	cli/mender-artifact/mender_test.img.broken \
	cli/mender-artifact/mender_test_fat.sdimg
export DH_GOLANG_EXCLUDES := github.com/mendersoftware/mender-artifact$
export DH_GOLANG_EXCLUDES_ALL := 0

%:
	dh $@ --buildsystem=golang --with=golang
	
override_dh_auto_build:
	dh_auto_build -O--buildsystem=golang -- \
		-ldflags "-X main.Version=$(DEB_VERSION)"

override_dh_auto_install:
	dh_auto_install
	# hmm... seems to be created by cli/mender-artifact/copy_test.go
	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/-
	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/foo
	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/foo.txt
	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/output.txt

## golang-github-mendersoftware-mender-artifact 3.0.1

=== Makefile ===
--- 
+++ 
@@ -2,13 +2,14 @@
 GOFMT ?= gofmt
 V ?=
 PKGS = $(shell go list ./... | grep -v vendor)
+SUBPKGS = $(shell go list ./... | sed '1d' | tr '\n' ',' | sed 's/,$$//1')
 BUILDFILES = $(shell find cli/mender-artifact \( -path ./vendor -o -path ./Godeps \) -prune \
 	                     -o -type f -name '*.go' -print |  tr ' ' '\n' | grep -v _test.go)
 PKGNAME = mender-artifact
 PKGFILES = $(shell find . \( -path ./vendor -o -path ./Godeps \) -prune \
 		-o -type f -name '*.go' -print)
 PKGFILES_notest = $(shell echo $(PKGFILES) | tr ' ' '\n' | grep -v _test.go)
-GOCYCLO ?= 15
+GOCYCLO ?= 20
 
 CGO_ENABLED=1
 export CGO_ENABLED
@@ -90,7 +91,7 @@
 	echo 'mode: set' > coverage.txt
 	set -e ; for p in $(PKGS); do \
 		rm -f coverage-tmp.txt;  \
-		$(GO) test -coverprofile=coverage-tmp.txt $$p ; \
+		$(GO) test -coverprofile=coverage-tmp.txt -coverpkg=$(SUBPKGS) $$p ; \
 		if [ -f coverage-tmp.txt ]; then \
 			cat coverage-tmp.txt |grep -v 'mode:' | cat >> coverage.txt; \
 		fi; \

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.0.1-2) unstable; urgency=medium

  * Cherry-pick upstream commit "Look for fsck.ext4 via GetBinaryPath"
  * Add patch to adjust cherry-picked path to current API
  * Don't remove mender_test images, needed by autopkgtests

 -- Andreas Henriksson <andreas@fatal.se>  Thu, 18 Jul 2019 16:32:38 +0200

golang-github-mendersoftware-mender-artifact (3.0.1-1) unstable; urgency=medium

  * New upstream version 3.0.1
  * Revert "Revert all Debian changes"
    - this brings back changes made in 3.0.0-* that was dropped in
      3.0.0+really2.4.0-1

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 09 Jul 2019 17:49:18 +0200

## golang-github-mendersoftware-mender-artifact 3.2.0

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.2.0-1) unstable; urgency=medium

  * New upstream version 3.2.0
  * Drop patch 0001-Do-not-close-the-pipe-in-TestCopyFromStdin-twice.patch

 -- Lluis Campos <lluis.campos@northern.tech>  Thu, 24 Oct 2019 14:31:23 +0200

golang-github-mendersoftware-mender-artifact (3.1.0-2) unstable; urgency=medium

  * Add debian/patches/0002-unfsck-TestDebugfs-caught-by-autopkgtests.patch
    - this should fix autopkgtests
  * Fix up syntax of previous changelog finishing last line.

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 20 Sep 2019 13:27:14 +0200

golang-github-mendersoftware-mender-artifact (3.1.0-1) unstable; urgency=medium

  * New upstream version 3.1.0
  * Drop old patches, all changes merged now upstream
  * Add patch to fix issue in unit tests

 -- Lluis Campos <lluis.campos@northern.tech>  Wed, 18 Sep 2019 14:46:47 +0200

## golang-github-mendersoftware-mender-artifact 3.2.1

=== Makefile ===
--- 
+++ 
@@ -42,11 +42,40 @@
 build:
 	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME) $(BUILDFILES)
 
+PLATFORMS := darwin linux windows
+
+GO_LDFLAGS_WIN = -ldflags "-X main.Version=$(VERSION) -linkmode=internal -s -w -extldflags '-static' -extld=x86_64-w64-mingw32-gcc"
+
+build-natives:
+	@arch="amd64";
+	@echo "building mac";
+	@env GOOS=darwin GOARCH=$$arch CGO_ENABLED=0 \
+		$(GO) build -a $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME)-darwin $(BUILDFILES) ;
+	@echo "building linux";
+	@env GOOS=linux GOARCH=$$arch \
+		$(GO) build -a $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME)-linux $(BUILDFILES) ;
+	@echo "building windows";
+	@env GOOS=windows GOARCH=$$arch CC=x86_64-w64-mingw32-gcc CXX=x86_64-w64-mingw32-g++ \
+		$(GO) build $(GO_LDFLAGS_WIN) $(BUILDV) -tags $(TAGS) nolzma -o $(PKGNAME)-windows.exe $(BUILDFILES) ;
+
+build-contained:
+	rm -f mender-artifact && \
+	image_id=$$(docker build -f Dockerfile . | awk '/Successfully built/{print $$NF;}') && \
+	docker run --rm --entrypoint "/bin/sh" -v $(shell pwd):/binary $$image_id -c "cp /go/bin/mender-artifact /binary" && \
+	docker image rm $$image_id
+
+build-natives-contained:
+	rm -f mender-artifact && \
+	image_id=$$(docker build -f Dockerfile.binaries . | awk '/Successfully built/{print $$NF;}') && \
+	docker run --rm --entrypoint "/bin/sh" -v $(shell pwd):/binary $$image_id -c "cp /go/bin/mender-artifact* /binary" && \
+	docker image rm $$image_id
+
 install:
 	cd $(INSTALL_DIR) && $(GO) install $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
 
 clean:
 	$(GO) clean
+	rm -f mender-artifact-darwin mender-artifact-linux mender-artifact-windows.exe
 	rm -f coverage.txt coverage-tmp.txt
 
 get-tools:

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.2.1-1) unstable; urgency=medium

  * New upstream version 3.2.1

 -- Lluis Campos <lluis.campos@northern.tech>  Tue, 10 Dec 2019 15:03:23 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
-Uploaders: Andreas Henriksson <andreas@fatal.se>
+Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
 Build-Depends: debhelper (>= 11),
                dh-golang,
                golang-any,
@@ -11,6 +11,7 @@
                golang-github-urfave-cli-dev,
                golang-logrus-dev,
                golang-github-mendersoftware-mendertesting-dev,
+               golang-github-remyoudompheng-go-liblzma-dev,
                e2fsprogs <!nocheck>,
                parted <!nocheck>,
                mtools <!nocheck>
@@ -25,6 +26,7 @@
 Architecture: all
 Depends: ${misc:Depends},
          golang-github-pkg-errors-dev,
+         golang-github-remyoudompheng-go-liblzma-dev,
          golang-github-stretchr-testify-dev,
          golang-github-urfave-cli-dev,
          golang-logrus-dev,

=== debian/rules ===
--- 
+++ 
@@ -19,8 +19,10 @@
 
 override_dh_auto_install:
 	dh_auto_install
-	# hmm... seems to be created by cli/mender-artifact/copy_test.go
+	# Test files created by cli/mender-artifact/copy_test.go
 	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/-
 	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/foo
 	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/foo.txt
 	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/output.txt
+	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/test.txt
+	rm -f debian/*/usr/share/gocode/src/github.com/mendersoftware/mender-artifact/cli/mender-artifact/dummy-file

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/golang-github-mendersoftware-mender-artifact-\$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha|b)[.]?(\d*)$/\$1~\$2\$3/ \
  https://github.com/mendersoftware/mender-artifact/tags .*/v?(\d\S*)\.tar\.gz

## golang-github-mendersoftware-mender-artifact 3.3.0

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.3.0-1) unstable; urgency=medium

  * Breaks against older mender-client using NewRootfsV1 API (Closes: #947135)
  * New upstream version 3.3.0
  * Refresh TestDebugfs patch to apply again
  * Add dosfstools to (build-)dependencies
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Repository, Repository-Browse.

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 08 Mar 2020 22:37:26 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                dh-golang,
                golang-any,
                golang-github-pkg-errors-dev,
@@ -12,6 +12,7 @@
                golang-logrus-dev,
                golang-github-mendersoftware-mendertesting-dev,
                golang-github-remyoudompheng-go-liblzma-dev,
+               dosfstools <!nocheck>,
                e2fsprogs <!nocheck>,
                parted <!nocheck>,
                mtools <!nocheck>
@@ -31,6 +32,7 @@
          golang-github-urfave-cli-dev,
          golang-logrus-dev,
          golang-github-mendersoftware-mendertesting-dev
+Breaks: mender-client (<< 2.1.2-2~)
 Description: Library for managing Mender artifact files
  Mender Artifacts Library Mender is an open source over-the-air (OTA)
  software updater for embedded Linux devices. Mender comprises a client
@@ -70,7 +72,7 @@
 Package: mender-artifact
 Architecture: any
 Built-Using: ${misc:Built-Using}
-Depends: ${misc:Depends}, ${shlibs:Depends}, e2fsprogs, parted, mtools
+Depends: ${misc:Depends}, ${shlibs:Depends}, dosfstools, e2fsprogs, parted, mtools
 Description: utility to generate .mender artifacts
  Mender Artifacts Library Mender is an open source over-the-air (OTA)
  software updater for embedded Linux devices. Mender comprises a client

## golang-github-mendersoftware-mender-artifact 3.4.0

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 V ?=
 PKGS = $(shell go list ./... | grep -v vendor)
 SUBPKGS = $(shell go list ./... | sed '1d' | tr '\n' ',' | sed 's/,$$//1')
-BUILDFILES = $(shell find cli/mender-artifact \( -path ./vendor -o -path ./Godeps \) -prune \
+BUILDFILES = $(shell find cli/mender-artifact -maxdepth 1 \( -path ./vendor -o -path ./Godeps \) -prune \
 	                     -o -type f -name '*.go' -print |  tr ' ' '\n' | grep -v _test.go)
 PKGNAME = mender-artifact
 PKGFILES = $(shell find . \( -path ./vendor -o -path ./Godeps \) -prune \

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.4.0-1build1) hirsute; urgency=medium

  * No-change rebuild using new golang

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 11 Nov 2020 22:12:47 +0000

golang-github-mendersoftware-mender-artifact (3.4.0-1) unstable; urgency=medium

  [ Andreas Henriksson ]
  * Bump version of Breaks: mender-client

  [ Lluis Campos ]
  * Add debian/patches/0001-Skip-TestLicense-for-Debian-Unit-Test-suite.patch
  * Remove dependency golang-github-mendersoftware-mendertesting-dev

  [ Andreas Henriksson ]
  * New upstream version 3.4.0
  * Update Skip TestLicense patch to apply again
  * Add new (build-)deps: klauspost/pgzip and minio/sha256-simd

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 27 Jul 2020 13:36:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: golang-github-mendersoftware-mender-artifact
 Section: devel
 Priority: optional
-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
@@ -10,7 +11,8 @@
                golang-github-stretchr-testify-dev,
                golang-github-urfave-cli-dev,
                golang-logrus-dev,
-               golang-github-mendersoftware-mendertesting-dev,
+               golang-github-klauspost-pgzip-dev,
+               golang-github-minio-sha256-simd-dev,
                golang-github-remyoudompheng-go-liblzma-dev,
                dosfstools <!nocheck>,
                e2fsprogs <!nocheck>,
@@ -27,12 +29,13 @@
 Architecture: all
 Depends: ${misc:Depends},
          golang-github-pkg-errors-dev,
+         golang-github-klauspost-pgzip-dev,
+         golang-github-minio-sha256-simd-dev,
          golang-github-remyoudompheng-go-liblzma-dev,
          golang-github-stretchr-testify-dev,
          golang-github-urfave-cli-dev,
          golang-logrus-dev,
-         golang-github-mendersoftware-mendertesting-dev
-Breaks: mender-client (<< 2.1.2-2~)
+Breaks: mender-client (<< 2.2.0-2~)
 Description: Library for managing Mender artifact files
  Mender Artifacts Library Mender is an open source over-the-air (OTA)
  software updater for embedded Linux devices. Mender comprises a client

## golang-github-mendersoftware-mender-artifact 3.6.0%2Bds1

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.6.0+ds1-2) unstable; urgency=medium

  * Add patch for urfave-cli 1.22.[45] compatibility.
    Thanks to Shengjing Zhu for the patch.
  * Upload to unstable.

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 17 Jan 2022 20:34:51 +0100

golang-github-mendersoftware-mender-artifact (3.6.0+ds1-1) experimental; urgency=medium

  * debian/watch: Use dversionmangle to append +ds1 suffix
  * New upstream release.
  * Add mender/progressbar build-dep
  * Drop d/p/0001-Skip-TestLicense-for-Debian-Unit-Test-suite.patch
    - Tests removed upstream.
  * Drop d/p/0002-unfsck-TestDebugfs-caught-by-autopkgtests.patch
    - Fixed upstream.
  * Update path to test files that where moved upstream
  * Add d/p/0001-Revert-cli-write_test-to-urfave-cli-1.22.5-compatibi.patch
  * Update to new method to pass -v (version) info to build
  * Use defaults for DH_GOLANG_EXCLUDES(_ALL) in debian/rules
  * Drop no longer needed cruft removal after install

 -- Andreas Henriksson <andreas@fatal.se>  Wed, 18 Aug 2021 11:46:50 +0200

## golang-github-mendersoftware-mender-artifact 3.6.0+ds1

=== Makefile ===
--- 
+++ 
@@ -3,8 +3,6 @@
 V ?=
 PKGS = $(shell go list ./... | grep -v vendor)
 SUBPKGS = $(shell go list ./... | sed '1d' | tr '\n' ',' | sed 's/,$$//1')
-BUILDFILES = $(shell find cli/mender-artifact -maxdepth 1 \( -path ./vendor -o -path ./Godeps \) -prune \
-	                     -o -type f -name '*.go' -print |  tr ' ' '\n' | grep -v _test.go)
 PKGNAME = mender-artifact
 PKGFILES = $(shell find . \( -path ./vendor -o -path ./Godeps \) -prune \
 		-o -type f -name '*.go' -print)
@@ -14,17 +12,15 @@
 CGO_ENABLED=1
 export CGO_ENABLED
 
-INSTALL_DIR=cli/mender-artifact
-
 TOOLS = \
-	github.com/fzipp/gocyclo \
+	github.com/fzipp/gocyclo/... \
 	github.com/opennota/check/cmd/varcheck \
 	github.com/mendersoftware/deadcode
 
 VERSION = $(shell git describe --tags --dirty --exact-match 2>/dev/null || git rev-parse --short HEAD)
 
 GO_LDFLAGS = \
-	-ldflags "-X main.Version=$(VERSION)"
+	-ldflags "-X github.com/mendersoftware/mender-artifact/cli.Version=$(VERSION)"
 
 ifeq ($(V),1)
 BUILDV = -v
@@ -40,23 +36,23 @@
 endif
 
 build:
-	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME) $(BUILDFILES)
+	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
 
 PLATFORMS := darwin linux windows
 
-GO_LDFLAGS_WIN = -ldflags "-X main.Version=$(VERSION) -linkmode=internal -s -w -extldflags '-static' -extld=x86_64-w64-mingw32-gcc"
+GO_LDFLAGS_WIN = -ldflags "-X github.com/mendersoftware/mender-artifact/cli.Version=$(VERSION) -linkmode=internal -s -w -extldflags '-static' -extld=x86_64-w64-mingw32-gcc"
 
 build-natives:
 	@arch="amd64";
 	@echo "building mac";
 	@env GOOS=darwin GOARCH=$$arch CGO_ENABLED=0 \
-		$(GO) build -a $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME)-darwin $(BUILDFILES) ;
+		$(GO) build -a $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME)-darwin ;
 	@echo "building linux";
 	@env GOOS=linux GOARCH=$$arch \
-		$(GO) build -a $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME)-linux $(BUILDFILES) ;
+		$(GO) build -a $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME)-linux ;
 	@echo "building windows";
 	@env GOOS=windows GOARCH=$$arch CC=x86_64-w64-mingw32-gcc CXX=x86_64-w64-mingw32-g++ \
-		$(GO) build $(GO_LDFLAGS_WIN) $(BUILDV) -tags $(TAGS) nolzma -o $(PKGNAME)-windows.exe $(BUILDFILES) ;
+		$(GO) build $(GO_LDFLAGS_WIN) $(BUILDV) -tags $(TAGS) nolzma -o $(PKGNAME)-windows.exe ;
 
 build-contained:
 	rm -f mender-artifact && \
@@ -71,7 +67,18 @@
 	docker image rm $$image_id
 
 install:
-	cd $(INSTALL_DIR) && $(GO) install $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
+	@$(GO) install $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
+
+install-autocomplete-scripts:
+	@echo "Installing Bash auto-complete script into ${DESTDIR}${PREFIX}/etc/bash_completion.d/"
+	@install -d ${DESTDIR}$(PREFIX)/etc/bash_completion.d/
+	@install -m 644 ./autocomplete/bash_autocomplete $(DESTDIR)$(PREFIX)/etc/bash_completion.d/mender-artifact
+	@if which zsh >/dev/null 2>&1 ; then \
+	echo "Installing zsh auto-complete script into ${DESTDIR}${PREFIX}/usr/local/share/zsh/site-functions/" \
+	install -d $(DESTDIR)$(PREFIX)/usr/local/share/zsh/site-functions/ && \
+	install -m 644 ./autocomplete/zsh_autocomplete $(DESTDIR)$(PREFIX)/usr/local/share/zsh/site-functions/_mender-artifact \
+	; fi
+
 
 clean:
 	$(GO) clean
@@ -83,6 +90,7 @@
 		echo "-- go getting $$t"; \
 		go get -u $$t; \
 	done
+	go mod vendor
 
 check: test extracheck
 
@@ -95,13 +103,13 @@
 
 extracheck:
 	echo "-- checking if code is gofmt'ed"
-	if [ -n "$$($(GOFMT) -d $(PKGFILES))" ]; then \
+	@if [ -n "$$($(GOFMT) -d $(PKGFILES))" ]; then \
+		"$$($(GOFMT) -d $(PKGFILES))" \
 		echo "-- gofmt check failed"; \
-		echo $GOFMT -d $PKGFILES \
 		/bin/false; \
 	fi
 	echo "-- checking with govet"
-	$(GO) tool vet -unsafeptr=false $(PKGFILES_notest)
+	$(GO) vet -unsafeptr=false
 	echo "-- checking for dead code"
 	deadcode
 	echo "-- checking with varcheck"

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: golang-github-mendersoftware-mender-artifact
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
@@ -12,6 +11,7 @@
                golang-github-urfave-cli-dev,
                golang-logrus-dev,
                golang-github-klauspost-pgzip-dev,
+               golang-github-mendersoftware-progressbar-dev (>= 0.0.3),
                golang-github-minio-sha256-simd-dev,
                golang-github-remyoudompheng-go-liblzma-dev,
                dosfstools <!nocheck>,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

#export DH_VERBOSE := 1
export DH_GOLANG_INSTALL_EXTRA := cli/mender_test.img \
	cli/mender_test.sdimg \
	cli/mender_test.img.broken \
	cli/mender_test_fat.sdimg

%:
	dh $@ --buildsystem=golang --with=golang
	
override_dh_auto_build:
	dh_auto_build -O--buildsystem=golang -- \
		-ldflags "-X github.com/mendersoftware/mender-artifact/cli.Version=$(DEB_VERSION)"

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%golang-github-mendersoftware-mender-artifact-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha|b)[.]?(\d*)$/\$1~\$2\$3/,\
      dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/mendersoftware/mender-artifact/tags .*/v?(\d\S*)\.tar\.gz debian

## golang-github-mendersoftware-mender-artifact 3.9.0+ds1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 GO ?= go
 GOFMT ?= gofmt
 V ?=
+PREFIX ?= /usr/local
 PKGS = $(shell go list ./... | grep -v vendor)
 SUBPKGS = $(shell go list ./... | sed '1d' | tr '\n' ',' | sed 's/,$$//1')
 PKGNAME = mender-artifact
@@ -15,7 +16,8 @@
 TOOLS = \
 	github.com/fzipp/gocyclo/... \
 	github.com/opennota/check/cmd/varcheck \
-	github.com/mendersoftware/deadcode
+	github.com/mendersoftware/deadcode \
+	github.com/mendersoftware/gobinarycoverage
 
 VERSION = $(shell git describe --tags --dirty --exact-match 2>/dev/null || git rev-parse --short HEAD)
 
@@ -56,13 +58,13 @@
 
 build-contained:
 	rm -f mender-artifact && \
-	image_id=$$(docker build -f Dockerfile . | awk '/Successfully built/{print $$NF;}') && \
+	image_id=$$(docker build -f Dockerfile -q .) && \
 	docker run --rm --entrypoint "/bin/sh" -v $(shell pwd):/binary $$image_id -c "cp /go/bin/mender-artifact /binary" && \
 	docker image rm $$image_id
 
 build-natives-contained:
-	rm -f mender-artifact && \
-	image_id=$$(docker build -f Dockerfile.binaries . | awk '/Successfully built/{print $$NF;}') && \
+	rm -f mender-artifact-darwin mender-artifact-linux mender-artifact-windows.exe && \
+	image_id=$$(docker build -f Dockerfile.binaries -q .) && \
 	docker run --rm --entrypoint "/bin/sh" -v $(shell pwd):/binary $$image_id -c "cp /go/bin/mender-artifact* /binary" && \
 	docker image rm $$image_id
 
@@ -70,13 +72,11 @@
 	@$(GO) install $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
 
 install-autocomplete-scripts:
-	@echo "Installing Bash auto-complete script into ${DESTDIR}${PREFIX}/etc/bash_completion.d/"
-	@install -d ${DESTDIR}$(PREFIX)/etc/bash_completion.d/
-	@install -m 644 ./autocomplete/bash_autocomplete $(DESTDIR)$(PREFIX)/etc/bash_completion.d/mender-artifact
+	@echo "Installing Bash auto-complete script into $(DESTDIR)/etc/bash_completion.d/"
+	@install -Dm0644 ./autocomplete/bash_autocomplete $(DESTDIR)/etc/bash_completion.d/mender-artifact
 	@if which zsh >/dev/null 2>&1 ; then \
-	echo "Installing zsh auto-complete script into ${DESTDIR}${PREFIX}/usr/local/share/zsh/site-functions/" \
-	install -d $(DESTDIR)$(PREFIX)/usr/local/share/zsh/site-functions/ && \
-	install -m 644 ./autocomplete/zsh_autocomplete $(DESTDIR)$(PREFIX)/usr/local/share/zsh/site-functions/_mender-artifact \
+		echo "Installing zsh auto-complete script into $(DESTDIR)$(PREFIX)/share/zsh/site-functions/" && \
+		install -Dm0644 ./autocomplete/zsh_autocomplete $(DESTDIR)$(PREFIX)/share/zsh/site-functions/_mender-artifact \
 	; fi
 
 
@@ -123,6 +123,10 @@
 htmlcover: coverage
 	$(GO) tool cover -html=coverage.txt
 
+instrument-binary:
+	git apply patches/0001-Instrument-with-coverage.patch
+	gobinarycoverage github.com/mendersoftware/mender-artifact
+
 coverage:
 	rm -f coverage.txt
 	echo 'mode: set' > coverage.txt
@@ -136,4 +140,5 @@
 	rm -f coverage-tmp.txt
 
 .PHONY: build clean get-tools test check \
-	cover htmlcover coverage tooldep
+	cover htmlcover coverage tooldep install-autocomplete-scripts \
+	instrument-binary

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (3.9.0+ds1-1) unstable; urgency=medium

  * New upstream version 3.9.0+ds1
  * Update vault signer removal patch
  * Add new build-dep golang-github-mendersoftware-openssl-dev
  * Bump mender-client Breaks because of API breakage
  * Build-dep on bugfixed mendersoftware-openssl package

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 14 Oct 2022 14:41:28 +0200

golang-github-mendersoftware-mender-artifact (3.8.0+ds1-1.1) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 10 Oct 2022 17:57:26 +0200

golang-github-mendersoftware-mender-artifact (3.8.0+ds1-1) experimental; urgency=medium

  * New upstream release.
  * Fix paths in gcp signer patch
  * Add debian/patches/0004-Remove-vault-signer.patch
  * Bump debhelper from old 12 to 13.
  * Add sparse sdimg to DH_GOLANG_INSTALL_EXTRA

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 10 Jun 2022 23:45:13 +0200

golang-github-mendersoftware-mender-artifact (3.7.0+ds1-1) experimental; urgency=medium

  * debian/watch: uversionmangle -build suffixes from upstream tags
  * New upstream version 3.7.0+ds1
  * Add build-deps needed by new gcp signer
    - golang-google-genproto-dev
    - golang-github-googleapis-gax-go-dev
    - golang-google-cloud-dev
    - golang-google-protobuf-dev
  * Add debian/patches/old-go-genproto.patch
    - cripple (crc checking in) GCP signer to build with older go-genproto
    - Once experimental golang-google-genproto-dev is in unstable, this
      should be dropped again. (Closes: #1004023)

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 15 Mar 2022 10:58:25 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Andreas Henriksson <andreas@fatal.se>, Lluis Campos <lluis.campos@northern.tech>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
                golang-github-pkg-errors-dev,
@@ -12,8 +12,13 @@
                golang-logrus-dev,
                golang-github-klauspost-pgzip-dev,
                golang-github-mendersoftware-progressbar-dev (>= 0.0.3),
+               golang-github-mendersoftware-openssl-dev (>= 1.1.0-4~),
                golang-github-minio-sha256-simd-dev,
                golang-github-remyoudompheng-go-liblzma-dev,
+               golang-google-genproto-dev,
+               golang-github-googleapis-gax-go-dev,
+               golang-google-cloud-dev,
+               golang-google-protobuf-dev,
                dosfstools <!nocheck>,
                e2fsprogs <!nocheck>,
                parted <!nocheck>,
@@ -35,7 +40,7 @@
          golang-github-stretchr-testify-dev,
          golang-github-urfave-cli-dev,
          golang-logrus-dev,
-Breaks: mender-client (<< 2.2.0-2~)
+Breaks: mender-client (<< 3.4.0)
 Description: Library for managing Mender artifact files
  Mender Artifacts Library Mender is an open source over-the-air (OTA)
  software updater for embedded Linux devices. Mender comprises a client

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,7 @@
 #export DH_VERBOSE := 1
 export DH_GOLANG_INSTALL_EXTRA := cli/mender_test.img \
 	cli/mender_test.sdimg \
+	cli/mender_test.sparse.sdimg \
 	cli/mender_test.img.broken \
 	cli/mender_test_fat.sdimg

## golang-github-mendersoftware-mender-artifact 4.1.0+ds1

=== Makefile ===
--- 
+++ 
@@ -2,13 +2,15 @@
 GOFMT ?= gofmt
 V ?=
 PREFIX ?= /usr/local
-PKGS = $(shell go list ./... | grep -v vendor)
-SUBPKGS = $(shell go list ./... | sed '1d' | tr '\n' ',' | sed 's/,$$//1')
+PKGS = $(shell go list ./... | tr '\n' ',' | head -c -1)
 PKGNAME = mender-artifact
 PKGFILES = $(shell find . \( -path ./vendor -o -path ./Godeps \) -prune \
 		-o -type f -name '*.go' -print)
 PKGFILES_notest = $(shell echo $(PKGFILES) | tr ' ' '\n' | grep -v _test.go)
 GOCYCLO ?= 20
+
+GOARCH ?= $(shell go env GOARCH)
+GOOS ?= $(shell go env GOOS)
 
 CGO_ENABLED=1
 export CGO_ENABLED
@@ -28,33 +30,40 @@
 BUILDV = -v
 endif
 
-TAGS =
-ifeq ($(LOCAL),1)
-TAGS += local
-endif
-
-ifneq ($(TAGS),)
-BUILDTAGS = -tags '$(TAGS)'
+TAGS ?=
+ifneq ($(GOOS),linux)
+	TAGS += nopkcs11
 endif
 
 build:
-	$(GO) build $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS)
+	$(GO) build $(GO_LDFLAGS) $(BUILDV) -tags '$(TAGS)'
 
 PLATFORMS := darwin linux windows
 
-GO_LDFLAGS_WIN = -ldflags "-X github.com/mendersoftware/mender-artifact/cli.Version=$(VERSION) -linkmode=internal -s -w -extldflags '-static' -extld=x86_64-w64-mingw32-gcc"
+$(PKGNAME)-%:
+	env CGO_ENABLED=$(CGO_ENABLED) \
+		GOARCH=$(GOARCH) \
+		GOOS=$(GOOS) \
+		go build \
+		    -a $(GO_LDFLAGS) $(BUILDV) -tags '$(TAGS)' \
+		    -o $@
 
-build-natives:
-	@arch="amd64";
-	@echo "building mac";
-	@env GOOS=darwin GOARCH=$$arch CGO_ENABLED=0 \
-		$(GO) build -a $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME)-darwin ;
-	@echo "building linux";
-	@env GOOS=linux GOARCH=$$arch \
-		$(GO) build -a $(GO_LDFLAGS) $(BUILDV) $(BUILDTAGS) -o $(PKGNAME)-linux ;
-	@echo "building windows";
-	@env GOOS=windows GOARCH=$$arch CC=x86_64-w64-mingw32-gcc CXX=x86_64-w64-mingw32-g++ \
-		$(GO) build $(GO_LDFLAGS_WIN) $(BUILDV) -tags $(TAGS) nolzma -o $(PKGNAME)-windows.exe ;
+.nopkcs11:
+	$(warning "WARNING: Building without pkcs11 support")
+
+build-native-linux: $(PKGNAME)-linux
+
+build-native-mac: GOOS = darwin
+build-native-mac: TAGS = nopkcs11
+build-native-mac: CGO_ENABLED = 0
+build-native-mac: .nopkcs11 $(PKGNAME)-darwin
+
+build-native-windows: GOOS = windows
+build-native-windows: TAGS = nopkcs11
+build-native-windows: GO_LDFLAGS = -ldflags "-X github.com/mendersoftware/mender-artifact/cli.Version=44d6905 -linkmode=internal -s -w -extldflags '-static' -extld=x86_64-w64-mingw32-gcc"
+build-native-windows: .nopkcs11 $(PKGNAME)-windows.exe
+
+build-natives: build-native-linux build-native-mac build-native-windows
 
 build-contained:
 	rm -f mender-artifact && \
@@ -92,6 +101,10 @@
 	done
 	go mod vendor
 
+get-build-deps:
+	apt-get update -qq
+	apt-get install -yyq $(shell cat deb-requirements.txt)
+
 check: test extracheck
 
 tooldep:
@@ -123,21 +136,16 @@
 htmlcover: coverage
 	$(GO) tool cover -html=coverage.txt
 
+instrument-binary-contained:
+	docker run --rm --name instrument-binary --entrypoint "/bin/sh" -v $(shell pwd):/go/src/github.com/mendersoftware/mender-artifact golang:1.22 -c "cd /go/src/github.com/mendersoftware/mender-artifact && go install github.com/mendersoftware/gobinarycoverage@latest && make instrument-binary"
+
 instrument-binary:
 	git apply patches/0001-Instrument-with-coverage.patch
 	gobinarycoverage github.com/mendersoftware/mender-artifact
 
 coverage:
 	rm -f coverage.txt
-	echo 'mode: set' > coverage.txt
-	set -e ; for p in $(PKGS); do \
-		rm -f coverage-tmp.txt;  \
-		$(GO) test -coverprofile=coverage-tmp.txt -coverpkg=$(SUBPKGS) $$p ; \
-		if [ -f coverage-tmp.txt ]; then \
-			cat coverage-tmp.txt |grep -v 'mode:' | cat >> coverage.txt; \
-		fi; \
-	done
-	rm -f coverage-tmp.txt
+	go test -tags '$(TAGS)' -covermode=atomic -coverpkg=$(PKGS) -coverprofile=coverage.txt ./...
 
 .PHONY: build clean get-tools test check \
 	cover htmlcover coverage tooldep install-autocomplete-scripts \

=== debian/changelog ===
golang-github-mendersoftware-mender-artifact (4.1.0+ds1-1) experimental; urgency=medium

  * New upstream release.
  * Add patches to remove azure signer
  * Unfuzz remove-vault patch
  * Unfuzz revert merge PR 559 patch
  * Add patch for rsa verification error message

 -- Andreas Henriksson <andreas@fatal.se>  Thu, 08 May 2025 13:29:33 +0200

golang-github-mendersoftware-mender-artifact (4.0.0+ds1-1) experimental; urgency=medium

  * New upstream release.
  * Drop urfave cli patches
  * Build-dep on golang-github-ulikunitz-xz-dev for lzma
  * Update debian/patches/0004-Remove-vault-signer.patch
  * Add patch to revert gcp import changes
  * Remove keyfactor signer

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 05 Jan 2025 17:58:19 +0100

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
                golang-github-mendersoftware-openssl-dev (>= 1.1.0-4~),
                golang-github-minio-sha256-simd-dev,
                golang-github-remyoudompheng-go-liblzma-dev,
+               golang-github-ulikunitz-xz-dev,
                golang-google-genproto-dev,
                golang-github-googleapis-gax-go-dev,
                golang-google-cloud-dev,
@@ -40,6 +41,7 @@
          golang-github-stretchr-testify-dev,
          golang-github-urfave-cli-dev,
          golang-logrus-dev,
+         golang-github-ulikunitz-xz-dev,
 Breaks: mender-client (<< 3.4.0)
 Description: Library for managing Mender artifact files
  Mender Artifacts Library Mender is an open source over-the-air (OTA)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%golang-github-mendersoftware-mender-artifact-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha|b)[.]?(\d*)$/\$1~\$2$3/,\
      uversionmangle=s/(\d)?(\-build\d*)?$/\$1/,\
      dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/mendersoftware/mender-artifact/tags .*/v?(\d\S*)\.tar\.gz debian
